Attribute VB_Name = "modEngine"
Option Explicit

Public Declare Function GetAsyncKeyState Lib "user32" (ByVal vKey As Long) As Integer
Public Declare Function GetTickCount Lib "Kernel32" () As Long
Public Declare Function ShowCursor Lib "user32" (ByVal bShow As Long) As Long
Public Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Public Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal lpString As String, ByVal nCount As Long) As Long
Public Declare Function SetBkMode Lib "gdi32" (ByVal hdc As Long, ByVal nBkMode As Long) As Long
Public Declare Function SetTextColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Public Declare Sub Sleep Lib "Kernel32" (ByVal dwMilliseconds As Long)

Public Const Pi As Double = 3.14159265358979
Public Const Radians As Double = (2 * Pi) / 360
Global Const Text_Transparent = 1 'Textout constant
Global Const Accel = 1            'Rate of increase of speed
Global Const Rotation_Rate = 9    'Rotation speed
Public MsngFacing As Single       'Angle the ship is facing (ok, ok, it's a triangle, not a ship! Shut it!)
Public MsngHeading As Single      'Current direction in which ship is moving
Public MsngSpeed As Single        'Current speed with which ship is moving
Public MsngX As Single            'Current X coordinate of ship within form
Public MsngY As Single
Public Shipx As Single, Shipy As Single, cell As Integer
Public Shields As Single          'Player's shields
Public Shield_Max As Integer
Global Const Bullet_Speed = 25    'Speed of a bullet
Public Bullet_Delay               'How many milliseconds between bullets?
Public BulletDelay As Long        'When was the last time the player fired?
Public enemy_Delay As Long
Public enemyDelay As Long
Public shipdir As Byte
Public ExplodingFrame As Byte
Public Explosions(0 To 9) As PointXY
Public Shipexploding As Boolean
Public Exploding As Boolean
Public Bulletspeed As Byte
Public BulletDim As Byte
Public ind_alien As Integer
Public OddsOfFiring As Byte
Public flgm As Integer
Public Keyright As Boolean
Public Keyleft As Boolean
Public Keycontrol As Boolean
Public Keyescape As Boolean
Public Keyup As Boolean
Public Keyspace As Boolean
Public angle  As Single
Public curX As Single, curY As Single
Public deltax As Double, deltay As Double
Public currHRes As Long
Public currVRes As Long
Public currBPP As Integer
Public currVFreq As Long

Public Type PointXY
    x As Integer
    y As Integer
End Type
Public Type Particles
    x As Integer
    y As Integer
    prtframe As Byte
    Activated As Boolean
End Type
Public Type BadBullet
    x As Integer
    y As Integer
    Velocity As Integer
    Activated As Integer
    angle As Integer
End Type

Public Type Sprite
    x As Integer
    y As Integer
    Width As Integer
    Height As Integer
    Status As Boolean
    Visible As Boolean
    frame As Byte
    Dir As Integer
    Damage As Integer
    Type As Byte
End Type
Public ShipSprite As Sprite
Public BonusType() As Sprite
Public Type Rock3
    x As Integer
    y As Integer
    Width As Integer
    Height As Integer
    Status As Boolean
    Visible As Boolean
    frame As Byte
    Dir As Integer
    Damage As Integer
    Type As Byte
    Exploding As Boolean
    frameExploding As Byte
    Particle(0 To 9) As Particles
End Type
Public Type Rock2
    x As Integer
    y As Integer
    Width As Integer
    Height As Integer
    Status As Boolean
    Visible As Boolean
    frame As Byte
    Dir As Integer
    Damage As Integer
    Type As Byte
    Exploding As Boolean
    frameExploding As Byte
    rocks3(0 To 2) As Rock3
    Particle(0 To 9) As Particles
End Type
Public Type Rock1
    x As Integer
    y As Integer
    Width As Integer
    Height As Integer
    Visible As Boolean
    Status As Boolean
    frame As Byte
    Dir As Integer
    Damage As Integer
    Type As Byte
    Exploding As Boolean
    Rocks2(0 To 1) As Rock2
    frameExploding As Byte
    Particle(0 To 9) As Particles
End Type
Public RockSprite(10) As Rock1
Public Type BadGuy
    Type As Byte
    Visible As Boolean
    Status As Boolean
    x As Integer
    y As Integer
    oldX As Integer
    oldY As Integer
    Exploding As Boolean
    frameExploding As Byte
    frame As Byte
    DstX As Integer
    DstY As Integer
    Damage As Integer
    Velocity As Integer
    Particle(0 To 9) As Particles
    Bulletc(0 To 10) As BadBullet
    Bulletca(0 To 10) As Double
    BulletsActivated As Byte
    bulletcxpos As Integer
    bulletcypos As Integer
    Firing As Byte
    shot As Boolean
End Type
Public BadGuys() As BadGuy

Public Type Bullettype
    x As Single
    y As Single
    Speed As Single
    Heading As Single
    Alive As Boolean
    Type As String
End Type
Public Bullet() As Bullettype

Public Keys As Integer
Public Bonus As Integer
Public Bonusnum As Integer
Public TypeBonus As Integer
Public Prtnum As Byte
Public NumRocks As Byte
Public Lives As Byte
Public Points As Double
Public ReturnValue As Long
Public Ind_spr As Integer
Public bLastHyperspace As Boolean
Public Gameloop As Boolean

Public Sub ExitProgram()
Dim Form As Form

'Terminate Music
modDXMusic.EndMusic
    
'Terminate DirectSound
Call Terminate_DSound

Set ds = Nothing

Unload frmMain
ShowCursor 1

'Restore Old Resolution
ChangeScreenSettings currHRes, currVRes, currBPP, currVFreq
   
End

End Sub
Public Sub Shoot()
Dim l As Integer
Dim freespot As Integer  'The first free spot in the bullet array
Dim XComp As Single      'The X component of the bullet's velocity
Dim YComp As Single      'The Y component of the bullet's velocity

    'Check if it's time for a new bullet
    If BulletDelay + Bullet_Delay < GetTickCount() Then
        'Reset the delay
        BulletDelay = GetTickCount()
        'Check the array for empty slots
        freespot = -1
        For l = 0 To UBound(Bullet)
            'Is this spot free?
            If Bullet(l).Alive = False Then
                freespot = l
                Exit For
            End If
        Next l
        'Make a new spot if there's no free ones
        If freespot = -1 Then
            ReDim Preserve Bullet(UBound(Bullet) + 1)
            freespot = UBound(Bullet)
        End If
        'Set the bullet's X,Y coords
        Bullet(freespot).x = Shipx + 22
        Bullet(freespot).y = Shipy + 14
        Bullet(freespot).Heading = MsngFacing
        'The bullet is alive!
        Bullet(freespot).Alive = True
        If frmMain.tmr_bullet.Enabled = False Then
           Bullet(freespot).Type = 1
        Else
           Bullet(freespot).Type = 2
        End If
        Call PlaySound(dsShoot1)
        'Determine the X and Y components of the resultant vector
        XComp = Sin(MsngHeading) + Bullet_Speed * Sin(MsngFacing)
        YComp = Cos(MsngHeading) + Bullet_Speed * Cos(MsngFacing)
        'Determine the resultant speed
        Bullet(freespot).Speed = Sqr(XComp ^ 2 + YComp ^ 2)
        'Calculate the resultant heading, and adjust for arctangent by adding Pi if necessary
        If Sgn(YComp) > 0 Then Bullet(freespot).Heading = Atn(XComp / YComp)
        If Sgn(YComp) < 0 Then Bullet(freespot).Heading = Atn(XComp / YComp) + Pi
         
   End If
End Sub
Public Sub KeyStatus()
'THANK YOU LUCKY

Dim sngXComp As Single  'Resultant X
                        '    and
Dim sngYComp As Single  'Y components
Dim sgnx As Integer     'Sign of Xcomp
Dim sgny As Integer     'Sign of Ycomp

If Keyescape = True Then Gameloop = False 'Quit Game

If Keyleft = True Then 'Turn Left
    cell = cell - 1
    If (cell < 0) Then cell = 39
    MsngFacing = MsngFacing - Rotation_Rate * Pi / 180
End If
If Keyright = True Then 'Turn Right
    cell = cell + 1
    If (cell > 39) Then cell = 0
    MsngFacing = MsngFacing + Rotation_Rate * Pi / 180
End If
                        
If cell * 9 >= 0 And cell * 9 < 45 Then shipdir = 0
If cell * 9 >= 45 And cell * 9 < 90 Then shipdir = 1
If cell * 9 >= 90 And cell * 9 < 135 Then shipdir = 2
If cell * 9 >= 135 And cell * 9 < 180 Then shipdir = 3
If cell * 9 >= 180 And cell * 9 < 225 Then shipdir = 4
If cell * 9 >= 225 And cell * 9 < 270 Then shipdir = 5
If cell * 9 >= 270 And cell * 9 < 315 Then shipdir = 6
If cell * 9 >= 315 And cell * 9 < 360 Then shipdir = 7

frmMain.PicAppom.Width = 51
frmMain.PicAppom.Height = 51
BitBlt frmMain.PicAppom.hdc, 0, 0, 51, 51, frmMain.picShipM.hdc, cell * 51, 0, vbSrcCopy

If Keyup = True Then 'Thrust
    If ShipSprite.Visible = True Then Call PlaySound(dsThrust)
    'Determine the X and Y components of the resultant vector
    sngXComp = MsngSpeed * Sin(MsngHeading) + Accel * Sin(MsngFacing)
    sngYComp = MsngSpeed * Cos(MsngHeading) + Accel * Cos(MsngFacing)
    sgnx = Sgn(sngXComp)
    sgny = Sgn(sngYComp)
    If sgnx = 1 And sgny = 1 Then ShipSprite.Dir = 3
    If sgnx = 1 And sgny = -1 Then ShipSprite.Dir = 1
    If sgnx = -1 And sgny = -1 Then ShipSprite.Dir = 2
    If sgnx = -1 And sgny = 1 Then ShipSprite.Dir = 4
    'Determine the resultant speed
    MsngSpeed = Sqr(sngXComp ^ 2 + sngYComp ^ 2)
    If MsngSpeed > 15 Then MsngSpeed = 15
    'Calculate the resultant heading, and adjust for arctangent by adding Pi if necessary
    If sngYComp > 0 Then MsngHeading = Atn(sngXComp / sngYComp)
    If sngYComp < 0 Then MsngHeading = Atn(sngXComp / sngYComp) + Pi
End If

If Keycontrol = True And ShipSprite.Visible = True Then Shoot

If Keyspace = True Then
    If Not bLastHyperspace Then
       'Hyperspace
       If ShipSprite.Visible = True Then Call PlaySound(dsJump)
       Shipx = (Rnd * frmMain.ScaleWidth) - 51
       Shipy = (Rnd * frmMain.ScaleHeight) - 51
       If Shipx <= 51 Then Shipx = 0
       If Shipy <= 51 Then Shipy = 0
       MsngSpeed = 0
       bLastHyperspace = True
    End If
Else
       bLastHyperspace = False
End If
End Sub
Public Sub Ship()
Dim q As Byte
If ShipSprite.Visible = True Then
   'Adjust coordinates of ship
   Shipx = Shipx + MsngSpeed * Sin(MsngHeading)
   Shipy = Shipy - MsngSpeed * Cos(MsngHeading)
    
   'Ensure that the ship is visible in the form
   If Shipx > frmMain.ScaleWidth Then Shipx = -51
   If Shipy > frmMain.ScaleHeight Then Shipy = -51
   If Shipx < -51 Then Shipx = frmMain.ScaleWidth
   If Shipy < -51 Then Shipy = frmMain.ScaleHeight
      If frmMain.Tmr_init.Interval Mod 2 > 0 Or frmMain.Tmr_init.Enabled = False Then
         ReturnValue = BitBlt(frmMain.picBuf.hdc, Shipx, Shipy, 51, 51, frmMain.picShipM.hdc, 51 * cell, 0, vbMergePaint)
         ReturnValue = BitBlt(frmMain.picBuf.hdc, Shipx, Shipy, 51, 51, frmMain.picShip.hdc, 51 * cell, 0, vbSrcAnd)
      End If
 End If
 If ShipSprite.Status = True Then
    If Shipexploding = True Then
      Shields = 0
      If Exploding = False Then
         For q = 0 To 5
             Explosions(q).x = Shipx - Int(Rnd * 51)
             Explosions(q).y = Shipy - Int(Rnd * 51)
         Next q
         ExplodingFrame = 1
         Exploding = True
      End If
      If ExplodingFrame = 1 Then Call PlaySound(dsShipxpl)
      If ExplodingFrame <> 0 Then
         For q = 0 To 5
             If q < 3 Then
                BitBlt frmMain.picBuf.hdc, Explosions(q).x, Explosions(q).y, 60, 60, frmMain.Explo1m.hdc, 60 * ExplodingFrame, 0, vbPatInvert
                BitBlt frmMain.picBuf.hdc, Explosions(q).x, Explosions(q).y, 60, 60, frmMain.Explo1.hdc, 60 * ExplodingFrame, 0, vbSrcPaint
             Else
                BitBlt frmMain.picBuf.hdc, Explosions(q).x, Explosions(q).y, 80, 70, frmMain.Explo2m.hdc, 80 * ExplodingFrame, 0, vbPatInvert
                BitBlt frmMain.picBuf.hdc, Explosions(q).x, Explosions(q).y, 80, 70, frmMain.Explo2.hdc, 80 * ExplodingFrame, 0, vbSrcPaint
             End If
         Next q
         ExplodingFrame = ExplodingFrame + 1
      End If

      If ExplodingFrame >= 14 Then
         Shipexploding = False
         ExplodingFrame = 0
         Lives = Lives - 1
         ShipSprite.Status = False
         If Lives = 0 Then
            Gameloop = False
            frmMain.tmr_end.Enabled = True
         Else
            frmMain.Tmr_init.Enabled = True
         End If
      End If
   End If
End If
End Sub
Public Sub Rocks()
Dim l As Integer, j As Integer
Dim freespot As Integer
Dim i As Byte, k As Byte, m As Byte, n As Byte, s As Byte, p As Byte, o As Byte, q As Byte

'Asteroid-Rock 1
For i = 0 To NumRocks
  If RockSprite(i).Status = True Then
    If RockSprite(i).Visible = True Then
      If RockSprite(i).Type = 1 Then
         frmMain.AppoPicm.Width = 74
         frmMain.AppoPicm.Height = 71
         BitBlt frmMain.AppoPicm.hdc, 0, 0, 74, 71, frmMain.Ast2m.hdc, RockSprite(i).frame * 74, 0, vbSrcCopy
      End If
      If RockSprite(i).Type = 2 Then
         frmMain.AppoPicm.Width = 76
         frmMain.AppoPicm.Height = 69
         BitBlt frmMain.AppoPicm.hdc, 0, 0, 76, 69, frmMain.Ast3m.hdc, RockSprite(i).frame * 76, 0, vbSrcCopy
      End If
     
      If RockSprite(i).Dir = 1 Then
         RockSprite(i).x = RockSprite(i).x + 5
         RockSprite(i).y = RockSprite(i).y + 5
      ElseIf RockSprite(i).Dir = 2 Then
         RockSprite(i).x = RockSprite(i).x - 5
         RockSprite(i).y = RockSprite(i).y + 5
      ElseIf RockSprite(i).Dir = 3 Then
         RockSprite(i).x = RockSprite(i).x + 5
         RockSprite(i).y = RockSprite(i).y - 5
      Else
         RockSprite(i).x = RockSprite(i).x - 5
         RockSprite(i).y = RockSprite(i).y - 5
      End If
      If RockSprite(i).Type = 1 Then
         If RockSprite(i).x > frmMain.ScaleWidth Then RockSprite(i).x = -74
         If RockSprite(i).y > frmMain.ScaleHeight Then RockSprite(i).y = -71
         If RockSprite(i).x < -74 Then RockSprite(i).x = frmMain.ScaleWidth
         If RockSprite(i).y < -71 Then RockSprite(i).y = frmMain.ScaleHeight
      End If
      If RockSprite(i).Type = 2 Then
         If RockSprite(i).x > frmMain.ScaleWidth Then RockSprite(i).x = -76
         If RockSprite(i).y > frmMain.ScaleHeight Then RockSprite(i).y = -69
         If RockSprite(i).x < -76 Then RockSprite(i).x = frmMain.ScaleWidth
         If RockSprite(i).y < -69 Then RockSprite(i).y = frmMain.ScaleHeight
      End If

      'Collision with Player
      If ShipSprite.Status = True And ((Shipx + 40 > RockSprite(i).x And Shipx < RockSprite(i).x + frmMain.AppoPicm.Width) And (Shipy + 40 > RockSprite(i).y And Shipy < RockSprite(i).y + frmMain.AppoPicm.Height)) Then
         RockSprite(i).Visible = False
         'You are Dead
         Shipexploding = True
         MsngSpeed = 0
         ShipSprite.Visible = False
         For n = 0 To 1
             RockSprite(i).Rocks2(n).x = RockSprite(i).x
             RockSprite(i).Rocks2(n).y = RockSprite(i).y
             RockSprite(i).Rocks2(n).frame = 0
             RockSprite(i).Rocks2(n).Damage = 0
             RockSprite(i).Rocks2(n).Status = True
             RockSprite(i).Rocks2(n).Visible = True
             RockSprite(i).Rocks2(n).Exploding = False
             If Shipx > RockSprite(i).x And Shipy > RockSprite(i).y Then
                RockSprite(i).Rocks2(0).Dir = 2
                RockSprite(i).Rocks2(1).Dir = 3
             End If
             If Shipx = RockSprite(i).x And Shipy > RockSprite(i).y Then
                RockSprite(i).Rocks2(0).Dir = 4
                RockSprite(i).Rocks2(1).Dir = 3
             End If
             If Shipx = RockSprite(i).x And Shipy < RockSprite(i).y Then
                RockSprite(i).Rocks2(0).Dir = 1
                RockSprite(i).Rocks2(1).Dir = 2
             End If
             If Shipx < RockSprite(i).x And Shipy > RockSprite(i).y Then
                RockSprite(i).Rocks2(0).Dir = 1
                RockSprite(i).Rocks2(1).Dir = 4
             End If
             If Shipx > RockSprite(i).x And Shipy < RockSprite(i).y Then
                RockSprite(i).Rocks2(0).Dir = 4
                RockSprite(i).Rocks2(1).Dir = 1
             End If
             If Shipx > RockSprite(i).x And Shipy = RockSprite(i).y Then
                RockSprite(i).Rocks2(0).Dir = 2
                RockSprite(i).Rocks2(1).Dir = 4
             End If
             If Shipx < RockSprite(i).x And Shipy = RockSprite(i).y Then
                RockSprite(i).Rocks2(0).Dir = 1
                RockSprite(i).Rocks2(1).Dir = 3
             End If
             If Shipx < RockSprite(i).x And Shipy < RockSprite(i).y Then
                RockSprite(i).Rocks2(0).Dir = 3
                RockSprite(i).Rocks2(1).Dir = 1
             End If
             RockSprite(i).Rocks2(n).Type = 1
         Next n
      End If

      'Collision with bullet
       For k = 0 To UBound(Bullet)
           If Bullet(k).Alive = True Then
              If Bullet(k).x + BulletDim > RockSprite(i).x And Bullet(k).x + BulletDim < RockSprite(i).x + frmMain.AppoPicm.Width And Bullet(k).y + BulletDim > RockSprite(i).y And Bullet(k).y + BulletDim < RockSprite(i).y + frmMain.AppoPicm.Height Then
                 Bullet(k).Alive = False
                 If Bullet(k).Type = 1 Then
                    RockSprite(i).Damage = RockSprite(i).Damage + 1
                 Else
                    RockSprite(i).Damage = RockSprite(i).Damage + 2.5
                 End If
                 If RockSprite(i).Damage >= 5 Then
                    RockSprite(i).Visible = False
                    RockSprite(i).Exploding = True
                    For n = 0 To 1
                        RockSprite(i).Rocks2(n).x = RockSprite(i).x - frmMain.AppoPicm.Width / 4
                        RockSprite(i).Rocks2(n).y = RockSprite(i).y - frmMain.AppoPicm.Width / 4
                        RockSprite(i).Rocks2(n).frame = 0
                        RockSprite(i).Rocks2(n).Damage = 0
                        RockSprite(i).Rocks2(n).Status = True
                        RockSprite(i).Rocks2(n).Visible = True
                        If shipdir = 0 Then
                           RockSprite(i).Rocks2(0).Dir = 4
                           RockSprite(i).Rocks2(1).Dir = 3
                        End If
                        If shipdir = 1 Then
                           RockSprite(i).Rocks2(0).Dir = 3
                           RockSprite(i).Rocks2(1).Dir = 1
                        End If
                        If shipdir = 2 Then
                           RockSprite(i).Rocks2(0).Dir = 1
                           RockSprite(i).Rocks2(1).Dir = 3
                        End If
                        If shipdir = 3 Then
                           RockSprite(i).Rocks2(0).Dir = 2
                           RockSprite(i).Rocks2(1).Dir = 1
                        End If
                        If shipdir = 4 Then
                           RockSprite(i).Rocks2(0).Dir = 1
                           RockSprite(i).Rocks2(1).Dir = 2
                        End If
                        If shipdir = 5 Then
                           RockSprite(i).Rocks2(0).Dir = 4
                           RockSprite(i).Rocks2(1).Dir = 2
                        End If
                        If shipdir = 6 Then
                           RockSprite(i).Rocks2(0).Dir = 2
                           RockSprite(i).Rocks2(1).Dir = 4
                        End If
                        If shipdir = 7 Then
                           RockSprite(i).Rocks2(0).Dir = 4
                           RockSprite(i).Rocks2(1).Dir = 3
                        End If
                                 
                        RockSprite(i).Rocks2(n).Type = 1
                    Next n
                 End If
              End If
           End If
      Next k
      
      'Show the sprite
      RockSprite(i).frame = RockSprite(i).frame + 1
      If RockSprite(i).Type = 1 Then
         If RockSprite(i).frame > 28 Then RockSprite(i).frame = 0
         ReturnValue = BitBlt(frmMain.picBuf.hdc, RockSprite(i).x, RockSprite(i).y, 74, 71, frmMain.Ast2m.hdc, 74 * RockSprite(i).frame, 0, vbMergePaint)
         ReturnValue = BitBlt(frmMain.picBuf.hdc, RockSprite(i).x, RockSprite(i).y, 74, 71, frmMain.Ast2.hdc, 74 * RockSprite(i).frame, 0, vbSrcAnd)
      ElseIf RockSprite(i).Type = 2 Then
         If RockSprite(i).frame > 28 Then RockSprite(i).frame = 0
         ReturnValue = BitBlt(frmMain.picBuf.hdc, RockSprite(i).x, RockSprite(i).y, 76, 69, frmMain.Ast3m.hdc, 76 * RockSprite(i).frame, 0, vbMergePaint)
         ReturnValue = BitBlt(frmMain.picBuf.hdc, RockSprite(i).x, RockSprite(i).y, 76, 69, frmMain.Ast3.hdc, 76 * RockSprite(i).frame, 0, vbSrcAnd)
      End If
    End If
    'Asteroid-Rock 1 Exploding
    If RockSprite(i).Exploding = True Then
       If RockSprite(i).frameExploding = 0 Then
           For s = 0 To 1
              Explosions(s).x = RockSprite(i).x - frmMain.AppoPicm.Width / 4
              Explosions(s).y = RockSprite(i).y - frmMain.AppoPicm.Height / 4
          Next s
          RockSprite(i).frameExploding = 1
          If RockSprite(i).frameExploding = 1 Then
             Call PlaySound(dsRock1xpl)
             'check for Bonus
             If Bonus = i Then
                If Bonusnum = 0 Then
                   For p = 0 To 9
                       RockSprite(i).Particle(p).x = RockSprite(i).x - frmMain.AppoPicm.Width / 32
                       RockSprite(i).Particle(p).y = RockSprite(i).y - frmMain.AppoPicm.Width / 32
                       RockSprite(i).Particle(p).Activated = True
                       Prtnum = 0
                   Next p
                   freespot = -1
                   For l = 0 To UBound(BonusType)
                       If BonusType(l).Status = False Then
                          freespot = l
                          Exit For
                       End If
                   Next l
                   If freespot = -1 Then
                      ReDim Preserve BonusType(UBound(BonusType) + 1)
                      freespot = UBound(BonusType)
                   End If
                   BonusType(freespot).x = RockSprite(i).x - frmMain.AppoPicm.Width / 32
                   BonusType(freespot).y = RockSprite(i).y - frmMain.AppoPicm.Width / 32
                   BonusType(freespot).Status = True
                   BonusType(freespot).Type = TypeBonus
                   BonusType(freespot).Dir = Int(Rnd * 4) + 1
                   BonusType(freespot).frame = 0
                End If
             End If
          End If
       End If
       If RockSprite(i).frameExploding <> 0 Then
          For s = 0 To 1
              If s = 0 Then
                 BitBlt frmMain.picBuf.hdc, Explosions(s).x, Explosions(s).y, 60, 60, frmMain.Explo1m.hdc, 60 * RockSprite(i).frameExploding, 0, vbPatInvert
                 BitBlt frmMain.picBuf.hdc, Explosions(s).x, Explosions(s).y, 60, 60, frmMain.Explo1.hdc, 60 * RockSprite(i).frameExploding, 0, vbSrcPaint
              Else
                 BitBlt frmMain.picBuf.hdc, Explosions(s).x, Explosions(s).y, 80, 70, frmMain.Explo2m.hdc, 80 * RockSprite(i).frameExploding, 0, vbPatInvert
                 BitBlt frmMain.picBuf.hdc, Explosions(s).x, Explosions(s).y, 80, 70, frmMain.Explo2.hdc, 80 * RockSprite(i).frameExploding, 0, vbSrcPaint
              End If
          Next s
          RockSprite(i).frameExploding = RockSprite(i).frameExploding + 1
       End If
  
       If RockSprite(i).frameExploding >= 14 Then
          RockSprite(i).Exploding = False
          RockSprite(i).frameExploding = 0
          Points = Points + 100
       End If
    End If
    
    'Asteroid-Rock 2
    For m = 0 To 1
    If RockSprite(i).Rocks2(m).Status = True Then
    If RockSprite(i).Rocks2(m).Visible = True Then
      If RockSprite(i).Rocks2(m).Type = 1 Then
         frmMain.AppoPicm.Width = 64
         frmMain.AppoPicm.Height = 58
         BitBlt frmMain.AppoPicm.hdc, 0, 0, 64, 58, frmMain.Ast1m.hdc, RockSprite(i).Rocks2(m).frame * 64, 0, vbSrcCopy
      End If
     
      If RockSprite(i).Rocks2(m).Dir = 1 Then
         RockSprite(i).Rocks2(m).x = RockSprite(i).Rocks2(m).x + 7
         RockSprite(i).Rocks2(m).y = RockSprite(i).Rocks2(m).y + 7
      ElseIf RockSprite(i).Rocks2(m).Dir = 2 Then
         RockSprite(i).Rocks2(m).x = RockSprite(i).Rocks2(m).x - 7
         RockSprite(i).Rocks2(m).y = RockSprite(i).Rocks2(m).y + 7
      ElseIf RockSprite(i).Rocks2(m).Dir = 3 Then
         RockSprite(i).Rocks2(m).x = RockSprite(i).Rocks2(m).x + 7
         RockSprite(i).Rocks2(m).y = RockSprite(i).Rocks2(m).y - 7
      Else
         RockSprite(i).Rocks2(m).x = RockSprite(i).Rocks2(m).x - 7
         RockSprite(i).Rocks2(m).y = RockSprite(i).Rocks2(m).y - 7
      End If
      If RockSprite(i).Rocks2(m).Type = 1 Then
         If RockSprite(i).Rocks2(m).x > frmMain.ScaleWidth Then RockSprite(i).Rocks2(m).x = -64
         If RockSprite(i).Rocks2(m).y > frmMain.ScaleHeight Then RockSprite(i).Rocks2(m).y = -58
         If RockSprite(i).Rocks2(m).x < -64 Then RockSprite(i).Rocks2(m).x = frmMain.ScaleWidth
         If RockSprite(i).Rocks2(m).y < -58 Then RockSprite(i).Rocks2(m).y = frmMain.ScaleHeight
      End If
      
      'Collision with Player
      If ShipSprite.Status = True And ((Shipx + 40 > RockSprite(i).Rocks2(m).x And Shipx < RockSprite(i).Rocks2(m).x + frmMain.AppoPicm.Width) And (Shipy + 40 > RockSprite(i).Rocks2(m).y And Shipy < RockSprite(i).Rocks2(m).y + frmMain.AppoPicm.Height)) Then
           RockSprite(i).Rocks2(m).Status = False
           RockSprite(i).Rocks2(m).Exploding = True
           RockSprite(i).Rocks2(m).Visible = False
           RockSprite(i).Rocks2(m).Damage = 3
           For q = 0 To 2
               RockSprite(i).Rocks2(m).rocks3(q).x = RockSprite(i).Rocks2(m).x - frmMain.AppoPicm.Width / 4
               RockSprite(i).Rocks2(m).rocks3(q).y = RockSprite(i).Rocks2(m).y - frmMain.AppoPicm.Width / 4
               RockSprite(i).Rocks2(m).rocks3(q).frame = 0
               RockSprite(i).Rocks2(m).rocks3(q).Damage = 0
               RockSprite(i).Rocks2(m).rocks3(q).Status = True
               RockSprite(i).Rocks2(m).rocks3(q).Visible = True
               If shipdir = 0 Then
                  RockSprite(i).Rocks2(m).rocks3(0).Dir = 4
                  RockSprite(i).Rocks2(m).rocks3(1).Dir = 3
                  RockSprite(i).Rocks2(m).rocks3(2).Dir = 1
               End If
               If shipdir = 1 Then
                  RockSprite(i).Rocks2(m).rocks3(0).Dir = 3
                  RockSprite(i).Rocks2(m).rocks3(1).Dir = 1
                  RockSprite(i).Rocks2(m).rocks3(2).Dir = 4
               End If
               If shipdir = 2 Then
                  RockSprite(i).Rocks2(m).rocks3(0).Dir = 1
                  RockSprite(i).Rocks2(m).rocks3(1).Dir = 3
                  RockSprite(i).Rocks2(m).rocks3(2).Dir = 2
               End If
               If shipdir = 3 Then
                  RockSprite(i).Rocks2(m).rocks3(0).Dir = 2
                  RockSprite(i).Rocks2(m).rocks3(1).Dir = 1
                  RockSprite(i).Rocks2(m).rocks3(2).Dir = 3
               End If
               If shipdir = 4 Then
                  RockSprite(i).Rocks2(m).rocks3(0).Dir = 1
                  RockSprite(i).Rocks2(m).rocks3(1).Dir = 2
                  RockSprite(i).Rocks2(m).rocks3(2).Dir = 4
               End If
               If shipdir = 5 Then
                  RockSprite(i).Rocks2(m).rocks3(0).Dir = 2
                  RockSprite(i).Rocks2(m).rocks3(1).Dir = 1
                  RockSprite(i).Rocks2(m).rocks3(2).Dir = 4
               End If
               If shipdir = 6 Then
                  RockSprite(i).Rocks2(m).rocks3(0).Dir = 2
                  RockSprite(i).Rocks2(m).rocks3(1).Dir = 4
                  RockSprite(i).Rocks2(m).rocks3(2).Dir = 3
               End If
               If shipdir = 7 Then
                  RockSprite(i).Rocks2(m).rocks3(0).Dir = 4
                  RockSprite(i).Rocks2(m).rocks3(1).Dir = 3
                  RockSprite(i).Rocks2(m).rocks3(2).Dir = 2
               End If
               RockSprite(i).Rocks2(m).rocks3(q).Type = 1
           Next q
           MsngSpeed = -(MsngSpeed + 4)
           Shields = Shields - 5
      End If
      
      'Collision with Bullet
       For k = 0 To UBound(Bullet)
           If Bullet(k).Alive = True Then
              If Bullet(k).x + BulletDim > RockSprite(i).Rocks2(m).x And Bullet(k).x + BulletDim < RockSprite(i).Rocks2(m).x + frmMain.AppoPicm.Width And Bullet(k).y + BulletDim > RockSprite(i).Rocks2(m).y And Bullet(k).y + BulletDim < RockSprite(i).Rocks2(m).y + frmMain.AppoPicm.Height Then
                 Bullet(k).Alive = False
                 If Bullet(k).Type = 1 Then
                    RockSprite(i).Rocks2(m).Damage = RockSprite(i).Rocks2(m).Damage + 1
                 Else
                    RockSprite(i).Rocks2(m).Damage = RockSprite(i).Rocks2(m).Damage + 3
                 End If
                 If RockSprite(i).Rocks2(m).Damage >= 3 Then
                    RockSprite(i).Rocks2(m).Visible = False
                    RockSprite(i).Rocks2(m).Exploding = True
                    For q = 0 To 2
                        RockSprite(i).Rocks2(m).rocks3(q).x = RockSprite(i).Rocks2(m).x - frmMain.AppoPicm.Width / 4
                        RockSprite(i).Rocks2(m).rocks3(q).y = RockSprite(i).Rocks2(m).y - frmMain.AppoPicm.Width / 4
                        RockSprite(i).Rocks2(m).rocks3(q).frame = 0
                        RockSprite(i).Rocks2(m).rocks3(q).Damage = 0
                        RockSprite(i).Rocks2(m).rocks3(q).Status = True
                        RockSprite(i).Rocks2(m).rocks3(q).Visible = True
                        If shipdir = 0 Then
                           RockSprite(i).Rocks2(m).rocks3(0).Dir = 4
                           RockSprite(i).Rocks2(m).rocks3(1).Dir = 3
                           RockSprite(i).Rocks2(m).rocks3(2).Dir = 2
                        End If
                        If shipdir = 1 Then
                           RockSprite(i).Rocks2(m).rocks3(0).Dir = 3
                           RockSprite(i).Rocks2(m).rocks3(1).Dir = 1
                           RockSprite(i).Rocks2(m).rocks3(2).Dir = 4
                        End If
                        If shipdir = 2 Then
                           RockSprite(i).Rocks2(m).rocks3(0).Dir = 1
                           RockSprite(i).Rocks2(m).rocks3(1).Dir = 3
                           RockSprite(i).Rocks2(m).rocks3(2).Dir = 4
                        End If
                        If shipdir = 3 Then
                           RockSprite(i).Rocks2(m).rocks3(0).Dir = 2
                           RockSprite(i).Rocks2(m).rocks3(1).Dir = 1
                           RockSprite(i).Rocks2(m).rocks3(2).Dir = 3
                        End If
                        If shipdir = 4 Then
                           RockSprite(i).Rocks2(m).rocks3(0).Dir = 1
                           RockSprite(i).Rocks2(m).rocks3(1).Dir = 2
                           RockSprite(i).Rocks2(m).rocks3(2).Dir = 4
                        End If
                        If shipdir = 5 Then
                           RockSprite(i).Rocks2(m).rocks3(0).Dir = 2
                           RockSprite(i).Rocks2(m).rocks3(1).Dir = 1
                           RockSprite(i).Rocks2(m).rocks3(2).Dir = 4
                        End If
                        If shipdir = 6 Then
                           RockSprite(i).Rocks2(m).rocks3(0).Dir = 2
                           RockSprite(i).Rocks2(m).rocks3(1).Dir = 4
                           RockSprite(i).Rocks2(m).rocks3(2).Dir = 3
                        End If
                        If shipdir = 7 Then
                           RockSprite(i).Rocks2(m).rocks3(0).Dir = 4
                           RockSprite(i).Rocks2(m).rocks3(1).Dir = 3
                           RockSprite(i).Rocks2(m).rocks3(2).Dir = 2
                        End If
                        RockSprite(i).Rocks2(m).rocks3(q).Type = 1
                    Next q
               
                 End If
              End If
           End If
      Next k
      
      'Show the sprite
      RockSprite(i).Rocks2(m).frame = RockSprite(i).Rocks2(m).frame + 1
      If RockSprite(i).Rocks2(m).frame > 44 Then RockSprite(i).Rocks2(m).frame = 0
      If RockSprite(i).Rocks2(m).Type = 1 Then
         ReturnValue = BitBlt(frmMain.picBuf.hdc, RockSprite(i).Rocks2(m).x, RockSprite(i).Rocks2(m).y, 64, 58, frmMain.Ast1m.hdc, 64 * RockSprite(i).Rocks2(m).frame, 0, vbMergePaint)
         ReturnValue = BitBlt(frmMain.picBuf.hdc, RockSprite(i).Rocks2(m).x, RockSprite(i).Rocks2(m).y, 64, 58, frmMain.Ast1.hdc, 64 * RockSprite(i).Rocks2(m).frame, 0, vbSrcAnd)
      End If
   End If
   End If
   If RockSprite(i).Rocks2(0).Damage >= 3 And RockSprite(i).Rocks2(0).Exploding = False And _
      RockSprite(i).Rocks2(1).Damage >= 3 And RockSprite(i).Rocks2(1).Exploding = False Then
      RockSprite(i).Rocks2(0).Damage = 0 And RockSprite(i).Rocks2(1).Damage = 0
   End If

   'Asteroid-Rock 2 Exploding
   If RockSprite(i).Rocks2(m).Exploding = True Then
      Explosions(0).x = RockSprite(i).Rocks2(m).x - frmMain.AppoPicm.Width / 4
      Explosions(0).y = RockSprite(i).Rocks2(m).y - frmMain.AppoPicm.Height / 4
      If RockSprite(i).Rocks2(m).frameExploding = 1 Then
         Call PlaySound(dsRock2xpl)
         'check for Bonus
         If Bonus = i Then
            If Bonusnum = 1 Then
               For p = 0 To 9
                   RockSprite(i).Rocks2(m).Particle(p).x = RockSprite(i).Rocks2(m).x - frmMain.AppoPicm.Width / 32
                   RockSprite(i).Rocks2(m).Particle(p).y = RockSprite(i).Rocks2(m).y - frmMain.AppoPicm.Width / 32
                   RockSprite(i).Rocks2(m).Particle(p).Activated = True
                   Prtnum = 1
               Next p
               freespot = -1
               For l = 0 To UBound(BonusType)
                   If BonusType(l).Status = False Then
                      freespot = l
                      Exit For
                   End If
                Next l
                If freespot = -1 Then
                   ReDim Preserve BonusType(UBound(BonusType) + 1)
                   freespot = UBound(BonusType)
                End If
                BonusType(freespot).x = RockSprite(i).Rocks2(m).x - frmMain.AppoPicm.Width / 32
                BonusType(freespot).y = RockSprite(i).Rocks2(m).y - frmMain.AppoPicm.Width / 32
                BonusType(freespot).Status = True
                BonusType(freespot).Type = TypeBonus
                BonusType(freespot).Dir = Int(Rnd * 4) + 1
                BonusType(freespot).frame = 0
            End If
         End If
      End If
      BitBlt frmMain.picBuf.hdc, Explosions(0).x, Explosions(0).y, 80, 70, frmMain.Explo2m.hdc, 80 * RockSprite(i).Rocks2(m).frameExploding, 0, vbPatInvert
      BitBlt frmMain.picBuf.hdc, Explosions(0).x, Explosions(0).y, 80, 70, frmMain.Explo2.hdc, 80 * RockSprite(i).Rocks2(m).frameExploding, 0, vbSrcPaint
      RockSprite(i).Rocks2(m).frameExploding = RockSprite(i).Rocks2(m).frameExploding + 1
      If RockSprite(i).Rocks2(m).frameExploding >= 14 Then
         RockSprite(i).Rocks2(m).Exploding = False
         RockSprite(i).Rocks2(m).frameExploding = 0
         Points = Points + 50
      End If
   End If
   
   'Asteroid-Rock 3
    For o = 0 To 2
        If RockSprite(i).Rocks2(m).rocks3(o).Status = True Then
        If RockSprite(i).Rocks2(m).rocks3(o).Visible = True Then
        If RockSprite(i).Rocks2(m).rocks3(o).Type = 1 Then
           frmMain.AppoPicm.Width = 37.5
           frmMain.AppoPicm.Height = 32
           BitBlt frmMain.AppoPicm.hdc, 0, 0, 37.5, 32, frmMain.Ast0m.hdc, RockSprite(i).Rocks2(m).rocks3(o).frame * 37, 0, vbSrcCopy
        End If
     
      If RockSprite(i).Rocks2(m).rocks3(o).Dir = 1 Then
         RockSprite(i).Rocks2(m).rocks3(o).x = RockSprite(i).Rocks2(m).rocks3(o).x + 9
         RockSprite(i).Rocks2(m).rocks3(o).y = RockSprite(i).Rocks2(m).rocks3(o).y + 9
      ElseIf RockSprite(i).Rocks2(m).rocks3(o).Dir = 2 Then
         RockSprite(i).Rocks2(m).rocks3(o).x = RockSprite(i).Rocks2(m).rocks3(o).x - 9
         RockSprite(i).Rocks2(m).rocks3(o).y = RockSprite(i).Rocks2(m).rocks3(o).y + 9
      ElseIf RockSprite(i).Rocks2(m).rocks3(o).Dir = 3 Then
         RockSprite(i).Rocks2(m).rocks3(o).x = RockSprite(i).Rocks2(m).rocks3(o).x + 9
         RockSprite(i).Rocks2(m).rocks3(o).y = RockSprite(i).Rocks2(m).rocks3(o).y - 9
      Else
         RockSprite(i).Rocks2(m).rocks3(o).x = RockSprite(i).Rocks2(m).rocks3(o).x - 9
         RockSprite(i).Rocks2(m).rocks3(o).y = RockSprite(i).Rocks2(m).rocks3(o).y - 9
      End If
      If RockSprite(i).Rocks2(m).rocks3(o).Type = 1 Then
         If RockSprite(i).Rocks2(m).rocks3(o).x > frmMain.ScaleWidth Then RockSprite(i).Rocks2(m).rocks3(o).x = -37
         If RockSprite(i).Rocks2(m).rocks3(o).y > frmMain.ScaleHeight Then RockSprite(i).Rocks2(m).rocks3(o).y = -32
         If RockSprite(i).Rocks2(m).rocks3(o).x < -37 Then RockSprite(i).Rocks2(m).rocks3(o).x = frmMain.ScaleWidth
         If RockSprite(i).Rocks2(m).rocks3(o).y < -32 Then RockSprite(i).Rocks2(m).rocks3(o).y = frmMain.ScaleHeight
      End If
      
      'Collision with Player
      If ShipSprite.Status = True And ((Shipx + 40 > RockSprite(i).Rocks2(m).rocks3(o).x And Shipx < RockSprite(i).Rocks2(m).rocks3(o).x + frmMain.AppoPicm.Width) And (Shipy + 40 > RockSprite(i).Rocks2(m).rocks3(o).y And Shipy < RockSprite(i).Rocks2(m).rocks3(o).y + frmMain.AppoPicm.Height)) Then
           RockSprite(i).Rocks2(m).rocks3(o).Exploding = True
           RockSprite(i).Rocks2(m).rocks3(o).Damage = 1
           MsngSpeed = -(MsngSpeed + 2)
           Shields = Shields - 2
      End If
      
      'Collision with Bullet
      For k = 0 To UBound(Bullet)
          If Bullet(k).Alive = True Then
             If Bullet(k).x + BulletDim > RockSprite(i).Rocks2(m).rocks3(o).x And Bullet(k).x + BulletDim < RockSprite(i).Rocks2(m).rocks3(o).x + frmMain.AppoPicm.Width And Bullet(k).y + BulletDim > RockSprite(i).Rocks2(m).rocks3(o).y And Bullet(k).y + BulletDim < RockSprite(i).Rocks2(m).rocks3(o).y + frmMain.AppoPicm.Height Then
                Bullet(k).Alive = False
                RockSprite(i).Rocks2(m).rocks3(o).Damage = 1
                RockSprite(i).Rocks2(m).rocks3(o).Exploding = True
             End If
          End If
      Next k
      
      'Show the sprite
      RockSprite(i).Rocks2(m).rocks3(o).frame = RockSprite(i).Rocks2(m).rocks3(o).frame + 1
      If RockSprite(i).Rocks2(m).rocks3(o).frame > 28 Then RockSprite(i).Rocks2(m).rocks3(o).frame = 0
      ReturnValue = BitBlt(frmMain.picBuf.hdc, RockSprite(i).Rocks2(m).rocks3(o).x, RockSprite(i).Rocks2(m).rocks3(o).y, 37.5, 32, frmMain.Ast0m.hdc, 37.5 * RockSprite(i).Rocks2(m).rocks3(o).frame, 0, vbMergePaint)
      ReturnValue = BitBlt(frmMain.picBuf.hdc, RockSprite(i).Rocks2(m).rocks3(o).x, RockSprite(i).Rocks2(m).rocks3(o).y, 37.5, 32, frmMain.Ast0.hdc, 37.5 * RockSprite(i).Rocks2(m).rocks3(o).frame, 0, vbSrcAnd)
   
   End If
   End If

   'Asteroid-Rock 3 Exploding
   If RockSprite(i).Rocks2(m).rocks3(o).Exploding = True Then
      Explosions(1).x = RockSprite(i).Rocks2(m).rocks3(o).x - frmMain.AppoPicm.Width / 4
      Explosions(1).y = RockSprite(i).Rocks2(m).rocks3(o).y - frmMain.AppoPicm.Height / 4
      RockSprite(i).Rocks2(m).rocks3(o).Visible = False
      If RockSprite(i).Rocks2(m).rocks3(o).frameExploding = 1 Then
         Call PlaySound(dsRock3xpl)
         'check for Bonus
         If Bonus = i Then
            If Bonusnum = 2 Then
               For p = 0 To 9
                   RockSprite(i).Rocks2(m).rocks3(o).Particle(p).x = RockSprite(i).Rocks2(m).rocks3(o).x - frmMain.AppoPicm.Width / 32
                   RockSprite(i).Rocks2(m).rocks3(o).Particle(p).y = RockSprite(i).Rocks2(m).rocks3(o).y - frmMain.AppoPicm.Width / 32
                   RockSprite(i).Rocks2(m).rocks3(o).Particle(p).Activated = True
                   Prtnum = 2
               Next p
               freespot = -1
               For l = 0 To UBound(BonusType)
                   If BonusType(l).Status = False Then
                      freespot = l
                      Exit For
                   End If
                Next l
                If freespot = -1 Then
                   ReDim Preserve BonusType(UBound(BonusType) + 1)
                   freespot = UBound(BonusType)
                End If
                BonusType(freespot).x = RockSprite(i).Rocks2(m).rocks3(o).x - frmMain.AppoPicm.Width / 32
                BonusType(freespot).y = RockSprite(i).Rocks2(m).rocks3(o).y - frmMain.AppoPicm.Width / 32
                BonusType(freespot).Status = True
                BonusType(freespot).Type = TypeBonus
                BonusType(freespot).Dir = Int(Rnd * 4) + 1
                BonusType(freespot).frame = 0
           End If
         End If
      End If
      BitBlt frmMain.picBuf.hdc, Explosions(1).x, Explosions(1).y, 60, 60, frmMain.Explo1m.hdc, 60 * RockSprite(i).Rocks2(m).rocks3(o).frameExploding, 0, vbPatInvert
      BitBlt frmMain.picBuf.hdc, Explosions(1).x, Explosions(1).y, 60, 60, frmMain.Explo1.hdc, 60 * RockSprite(i).Rocks2(m).rocks3(o).frameExploding, 0, vbSrcPaint
      RockSprite(i).Rocks2(m).rocks3(o).frameExploding = RockSprite(i).Rocks2(m).rocks3(o).frameExploding + 1

      If RockSprite(i).Rocks2(m).rocks3(o).frameExploding >= 14 Then
         RockSprite(i).Rocks2(m).rocks3(o).Exploding = False
         RockSprite(i).Rocks2(m).rocks3(o).frameExploding = 0
         Points = Points + 25
         If RockSprite(i).Rocks2(0).rocks3(0).Damage = 1 And _
            RockSprite(i).Rocks2(0).rocks3(1).Damage = 1 And _
            RockSprite(i).Rocks2(0).rocks3(2).Damage = 1 And _
            RockSprite(i).Rocks2(1).rocks3(0).Damage = 1 And _
            RockSprite(i).Rocks2(1).rocks3(1).Damage = 1 And _
            RockSprite(i).Rocks2(1).rocks3(2).Damage = 1 Then
            RockSprite(i).Rocks2(0).rocks3(0).Damage = 0 And RockSprite(i).Rocks2(0).rocks3(1).Damage = 0 And RockSprite(i).Rocks2(0).rocks3(2).Damage = 0
            RockSprite(i).Rocks2(1).rocks3(0).Damage = 0 And RockSprite(i).Rocks2(1).rocks3(1).Damage = 0 And RockSprite(i).Rocks2(1).rocks3(2).Damage = 0
            RockSprite(i).Rocks2(0).Damage = 0 And RockSprite(i).Rocks2(1).Damage = 0
            RockSprite(i).Rocks2(0).Status = False
            RockSprite(i).Rocks2(1).Status = False
            RockSprite(i).Status = False
         End If
      End If
   End If
   If Prtnum = 2 Then 'Have Bonus - Rock3
      For p = 0 To 9
          If RockSprite(i).Rocks2(m).rocks3(o).Particle(p).Activated Then
             RockSprite(i).Rocks2(m).rocks3(o).Particle(p).x = RockSprite(i).Rocks2(m).rocks3(o).Particle(p).x + (Cos((36 * p) * Radians) * 10)
             RockSprite(i).Rocks2(m).rocks3(o).Particle(p).y = RockSprite(i).Rocks2(m).rocks3(o).Particle(p).y + (Sin((36 * p) * Radians) * 10)
             If RockSprite(i).Rocks2(m).rocks3(o).Particle(p).x > frmMain.ScaleWidth Or _
                RockSprite(i).Rocks2(m).rocks3(o).Particle(p).y > frmMain.ScaleHeight Or _
                RockSprite(i).Rocks2(m).rocks3(o).Particle(p).x < frmMain.ScaleLeft Or _
                RockSprite(i).Rocks2(m).rocks3(o).Particle(p).y < frmMain.ScaleTop Then RockSprite(i).Rocks2(m).rocks3(o).Particle(p).Activated = False
                ReturnValue = BitBlt(frmMain.picBuf.hdc, RockSprite(i).Rocks2(m).rocks3(o).Particle(p).x, RockSprite(i).Rocks2(m).rocks3(o).Particle(p).y, 6, 6, frmMain.PicBullet1M.hdc, 0, 0, vbMergePaint)
                ReturnValue = BitBlt(frmMain.picBuf.hdc, RockSprite(i).Rocks2(m).rocks3(o).Particle(p).x, RockSprite(i).Rocks2(m).rocks3(o).Particle(p).y, 6, 6, frmMain.PicPrt.hdc, 0, 0, vbSrcAnd)
          End If
      Next p
   End If
   Next o
   If Prtnum = 1 Then 'Have Bonus - Rock2
      For p = 0 To 9
          If RockSprite(i).Rocks2(m).Particle(p).Activated Then
             RockSprite(i).Rocks2(m).Particle(p).x = RockSprite(i).Rocks2(m).Particle(p).x + (Cos((36 * p) * Radians) * 10)
             RockSprite(i).Rocks2(m).Particle(p).y = RockSprite(i).Rocks2(m).Particle(p).y + (Sin((36 * p) * Radians) * 10)
             If RockSprite(i).Rocks2(m).Particle(p).x > frmMain.ScaleWidth Or _
                RockSprite(i).Rocks2(m).Particle(p).y > frmMain.ScaleHeight Or _
                RockSprite(i).Rocks2(m).Particle(p).x < frmMain.ScaleLeft Or _
                RockSprite(i).Rocks2(m).Particle(p).y < frmMain.ScaleTop Then RockSprite(i).Rocks2(m).Particle(p).Activated = False
                ReturnValue = BitBlt(frmMain.picBuf.hdc, RockSprite(i).Rocks2(m).Particle(p).x, RockSprite(i).Rocks2(m).Particle(p).y, 6, 6, frmMain.PicBullet1M.hdc, 0, 0, vbMergePaint)
                ReturnValue = BitBlt(frmMain.picBuf.hdc, RockSprite(i).Rocks2(m).Particle(p).x, RockSprite(i).Rocks2(m).Particle(p).y, 6, 6, frmMain.PicPrt.hdc, 0, 0, vbSrcAnd)
          End If
      Next p
   End If
   Next m
   If Prtnum = 0 Then 'Have Bonus - Rock1
      For p = 0 To 9
          If RockSprite(i).Particle(p).Activated Then
             RockSprite(i).Particle(p).x = RockSprite(i).Particle(p).x + (Cos((36 * p) * Radians) * 10)
             RockSprite(i).Particle(p).y = RockSprite(i).Particle(p).y + (Sin((36 * p) * Radians) * 10)
             If RockSprite(i).Particle(p).x > frmMain.ScaleWidth Or _
                RockSprite(i).Particle(p).y > frmMain.ScaleHeight Or _
                RockSprite(i).Particle(p).x < frmMain.ScaleLeft Or _
                RockSprite(i).Particle(p).y < frmMain.ScaleTop Then RockSprite(i).Particle(p).Activated = False
                ReturnValue = BitBlt(frmMain.picBuf.hdc, RockSprite(i).Particle(p).x, RockSprite(i).Particle(p).y, 6, 6, frmMain.PicBullet1M.hdc, 0, 0, vbMergePaint)
                ReturnValue = BitBlt(frmMain.picBuf.hdc, RockSprite(i).Particle(p).x, RockSprite(i).Particle(p).y, 6, 6, frmMain.PicPrt.hdc, 0, 0, vbSrcAnd)
          End If
      Next p
   End If
   Else
      Ind_spr = i
      If enemyDelay + enemy_Delay < GetTickCount() Then
         enemyDelay = GetTickCount()
         RockSprite(Ind_spr).x = Rnd * frmMain.ScaleLeft - 100
         RockSprite(Ind_spr).y = Rnd * frmMain.ScaleTop - 100
         RockSprite(Ind_spr).frame = 0
         RockSprite(Ind_spr).frameExploding = 0
         RockSprite(Ind_spr).Damage = 0
         RockSprite(Ind_spr).Status = True
         RockSprite(Ind_spr).Visible = True
         RockSprite(Ind_spr).Dir = Int(Rnd * 4) + 1
         RockSprite(Ind_spr).Type = Int(Rnd * 2) + 1
         RockSprite(Ind_spr).Exploding = False
       End If
   End If

Next i
For j = 0 To UBound(BonusType)
If BonusType(j).Status = True Then
   If BonusType(j).Dir = 1 Then
      BonusType(j).x = BonusType(j).x + 3
      BonusType(j).y = BonusType(j).y + 3
      ElseIf BonusType(j).Dir = 2 Then
         BonusType(j).x = BonusType(j).x - 3
         BonusType(j).y = BonusType(j).y + 3
      ElseIf BonusType(j).Dir = 3 Then
         BonusType(j).x = BonusType(j).x + 3
         BonusType(j).y = BonusType(j).y - 3
      Else
         BonusType(j).x = BonusType(j).x - 3
         BonusType(j).y = BonusType(j).y - 3
      End If
      If BonusType(j).x > frmMain.ScaleWidth Or _
         BonusType(j).y > frmMain.ScaleHeight Or _
         BonusType(j).x < frmMain.ScaleLeft Or _
         BonusType(j).y < frmMain.ScaleTop Then BonusType(j).Status = False
      If ((Shipx + 40 > BonusType(j).x And Shipx < BonusType(j).x + 16) And (Shipy + 40 > BonusType(j).y And Shipy < BonusType(j).y + 15)) Then
         BonusType(j).Status = False
         If BonusType(j).Type = 0 Then
             If frmMain.tmr_bullet.Enabled = False Then
                Call PlaySound(dsShoot2)
                frmMain.tmr_bullet.Enabled = True
             End If
         ElseIf BonusType(j).Type = 1 Then
            Call PlaySound(dsShield)
            Shields = 25
         Else
            Call PlaySound(dsLives)
            Lives = Lives + 1
         End If
      End If
      If BonusType(j).Type = 0 Then
         ReturnValue = BitBlt(frmMain.picBuf.hdc, BonusType(j).x, BonusType(j).y, 16, 15, frmMain.Bonus2m.hdc, 16 * BonusType(j).frame, 0, vbMergePaint)
         ReturnValue = BitBlt(frmMain.picBuf.hdc, BonusType(j).x, BonusType(j).y, 16, 15, frmMain.Bonus2.hdc, 16 * BonusType(j).frame, 0, vbSrcAnd)
      ElseIf BonusType(j).Type = 1 Then
         ReturnValue = BitBlt(frmMain.picBuf.hdc, BonusType(j).x, BonusType(j).y, 16, 15, frmMain.Bonus1m.hdc, 16 * BonusType(j).frame, 0, vbMergePaint)
         ReturnValue = BitBlt(frmMain.picBuf.hdc, BonusType(j).x, BonusType(j).y, 16, 15, frmMain.Bonus1.hdc, 16 * BonusType(j).frame, 0, vbSrcAnd)
      Else
         ReturnValue = BitBlt(frmMain.picBuf.hdc, BonusType(j).x, BonusType(j).y, 16, 15, frmMain.PicLifem.hdc, 16 * BonusType(j).frame, 0, vbMergePaint)
         ReturnValue = BitBlt(frmMain.picBuf.hdc, BonusType(j).x, BonusType(j).y, 16, 15, frmMain.PicLife.hdc, 16 * BonusType(j).frame, 0, vbSrcAnd)
      End If
      BonusType(j).frame = BonusType(j).frame + 1
      If BonusType(j).frame > 19 Then BonusType(j).frame = 0
End If
Next j
End Sub
Public Sub Bullets()
Dim h As Byte

    For h = 0 To UBound(Bullet)
        'Only draw "live" bullets
        If Bullet(h).Alive = True Then
           If Bullet(h).Type = 1 Then BulletDim = 6 Else BulletDim = 8
           'Adjust bullet coordinates
            Bullet(h).x = Bullet(h).x + Bullet(h).Speed * Sin(Bullet(h).Heading)
            Bullet(h).y = Bullet(h).y - Bullet(h).Speed * Cos(Bullet(h).Heading)
            If Bullet(h).x > frmMain.ScaleWidth Or _
               Bullet(h).y > frmMain.ScaleHeight Or _
               Bullet(h).x < -BulletDim Or _
               Bullet(h).y < -BulletDim Then Bullet(h).Alive = False
            If Bullet(h).Type = 1 Then
               ReturnValue = BitBlt(frmMain.picBuf.hdc, Bullet(h).x, Bullet(h).y, BulletDim, BulletDim, frmMain.PicBullet1M.hdc, 0, 0, vbMergePaint)
               ReturnValue = BitBlt(frmMain.picBuf.hdc, Bullet(h).x, Bullet(h).y, BulletDim, BulletDim, frmMain.PicBullet1.hdc, 0, 0, vbSrcAnd)
            Else
               ReturnValue = BitBlt(frmMain.picBuf.hdc, Bullet(h).x, Bullet(h).y, BulletDim, BulletDim, frmMain.PicBullet2M.hdc, 0, 0, vbMergePaint)
               ReturnValue = BitBlt(frmMain.picBuf.hdc, Bullet(h).x, Bullet(h).y, BulletDim, BulletDim, frmMain.PicBullet2.hdc, 0, 0, vbSrcAnd)
            End If
        End If
    Next h
End Sub
Public Sub InitShip()
Dim a As Byte, b As Byte, c As Byte
    ShipSprite.Visible = True
    cell = 0
    MsngSpeed = 0
    MsngFacing = 0
    MsngHeading = 0
    Shipexploding = False
    Exploding = False
    Shipx = (frmMain.picBuf.ScaleWidth - 51) / 2
    Shipy = (frmMain.picBuf.ScaleHeight - 51) / 2
    Shield_Max = 25
    Shields = Shield_Max
End Sub
Public Sub DoTextOut(Text As String, x As Integer, y As Integer, DC As Long, Colour As Long)
'Set the background to transparent
SetBkMode DC, Text_Transparent
'Set the colour of the text
SetTextColor DC, Colour
'Draw it!
TextOut DC, x, y, Text, Len(Text)
End Sub
Public Sub Enemy()
Dim freespot As Integer, i As Byte, k As Byte, l As Byte, p As Byte, s As Byte, o As Byte, j As Byte
For i = 0 To UBound(BadGuys)
If BadGuys(i).Status = True Then
      If BadGuys(i).Type = 1 Then
         frmMain.AppoPicm.Width = 64
         frmMain.AppoPicm.Height = 64
         BitBlt frmMain.AppoPicm.hdc, 0, 0, 64, 64, frmMain.PicAlien1m.hdc, BadGuys(i).frame * 64, 0, vbSrcCopy
      End If
      If BadGuys(i).Type = 2 Then
         frmMain.AppoPicm.Width = 64
         frmMain.AppoPicm.Height = 64
         BitBlt frmMain.AppoPicm.hdc, 0, 0, 64, 64, frmMain.PicAlien2m.hdc, BadGuys(i).frame * 64, 0, vbSrcCopy
      End If
     
    BadGuys(i).oldX = BadGuys(i).x
    BadGuys(i).oldY = BadGuys(i).y
    If BadGuys(i).DstX < BadGuys(i).x Then
        BadGuys(i).x = (BadGuys(i).x - BadGuys(i).Velocity) + 2
    Else
        BadGuys(i).x = BadGuys(i).x + BadGuys(i).Velocity
    End If
    If BadGuys(i).y >= (frmMain.ScaleTop + 150) And flgm = 0 Then
       flgm = 1
       BadGuys(i).DstY = Rnd * (frmMain.ScaleHeight - 200)
    End If
    If flgm = 1 Then
       If BadGuys(i).DstY < BadGuys(i).y Then
          BadGuys(i).y = (BadGuys(i).y - BadGuys(i).Velocity) + 2
       Else
          BadGuys(i).y = BadGuys(i).y + BadGuys(i).Velocity
       End If
     End If
 
    If flgm = 0 Then BadGuys(i).y = BadGuys(i).y + BadGuys(i).Velocity
    If Abs(BadGuys(i).x - BadGuys(i).DstX) < 5 Then BadGuys(i).DstX = Rnd * (frmMain.ScaleWidth - 64)
    If Abs(BadGuys(i).y - BadGuys(i).DstY) < 5 Then BadGuys(i).DstY = Rnd * (frmMain.ScaleHeight - 64)
   
   
    If BadGuys(i).Status = True Then
       BadGuys(i).Firing = Int(Rnd * OddsOfFiring)
    Else
       BadGuys(i).Firing = 0
    End If

   'Firing bullets
   If BadGuys(i).y > frmMain.ScaleTop + 10 Then

   For o = 0 To 9
      If BadGuys(i).Status = True Then
         If BadGuys(i).Firing = 1 Then
           If BadGuys(i).Bulletc(o).Activated = 0 Then
              BadGuys(i).Bulletc(o).Activated = 1
              BadGuys(i).shot = True
              BadGuys(i).bulletcxpos = 32
              BadGuys(i).bulletcypos = 32
              BadGuys(i).Bulletc(o).x = BadGuys(i).x + BadGuys(i).bulletcxpos + Int(Rnd * (o * 10))
              BadGuys(i).Bulletc(o).y = BadGuys(i).y + BadGuys(i).bulletcypos + Int(Rnd * (o * 10))
'              BadGuys(i).Bulletc(0).x = BadGuys(i).x + BadGuys(i).bulletcxpos
'              BadGuys(i).Bulletc(0).y = BadGuys(i).y + BadGuys(i).bulletcypos
'              curX = BadGuys(i).Bulletc(0).x
'              curY = BadGuys(i).Bulletc(0).y
'              AngleRadians
'              BadGuys(i).Bulletca(0) = angle
           End If

           If BadGuys(i).shot = True And BadGuys(i).Bulletc(o).Activated = 1 Then
              Call PlaySound(dsShot)
              BadGuys(i).shot = False
           End If

         End If
      End If

   Next o
   End If

   BadGuys(i).frame = BadGuys(i).frame + 1
   If BadGuys(i).frame > 19 Then BadGuys(i).frame = 0
'   If BadGuys(i).frame = 0 Then Call PlaySound(dsAlien)
   Call PlaySound(dsAlien)
   If BadGuys(i).Type = 1 Then
      ReturnValue = BitBlt(frmMain.picBuf.hdc, BadGuys(i).x, BadGuys(i).y, 64, 64, frmMain.PicAlien1m.hdc, 64 * BadGuys(i).frame, 0, vbMergePaint)
      ReturnValue = BitBlt(frmMain.picBuf.hdc, BadGuys(i).x, BadGuys(i).y, 64, 64, frmMain.PicAlien1.hdc, 64 * BadGuys(i).frame, 0, vbSrcAnd)
   Else
      ReturnValue = BitBlt(frmMain.picBuf.hdc, BadGuys(i).x, BadGuys(i).y, 64, 64, frmMain.PicAlien2m.hdc, 64 * BadGuys(i).frame, 0, vbMergePaint)
      ReturnValue = BitBlt(frmMain.picBuf.hdc, BadGuys(i).x, BadGuys(i).y, 64, 64, frmMain.PicAlien2.hdc, 64 * BadGuys(i).frame, 0, vbSrcAnd)
   End If
   For k = 0 To UBound(Bullet)
       If Bullet(k).Alive = True Then
          If Bullet(k).x + BulletDim > BadGuys(i).x And Bullet(k).x + BulletDim < BadGuys(i).x + 64 And Bullet(k).y + BulletDim > BadGuys(i).y And Bullet(k).y + BulletDim < BadGuys(i).y + 64 Then
             Call PlaySound(dsHit)
              Bullet(k).Alive = False
              If Bullet(k).Type = 1 Then
                 BadGuys(i).Damage = BadGuys(i).Damage + 1
              Else
                 BadGuys(i).Damage = BadGuys(i).Damage + 2.5
              End If
              If BadGuys(i).Damage >= 5 Then
                 BadGuys(i).Status = False
                 BadGuys(i).Visible = False
                 BadGuys(i).Exploding = True
              End If
          End If
       End If
   Next k
  If ShipSprite.Status = True And ((Shipx + 40 > BadGuys(i).x And Shipx < BadGuys(i).x + 64) And (Shipy + 40 > BadGuys(i).y And Shipy < BadGuys(i).y + 64)) Then
     Shipexploding = True
     BadGuys(i).Status = False
     BadGuys(i).Visible = False
     BadGuys(i).Exploding = True
  End If

End If
Next i

For i = 0 To UBound(BadGuys)
For j = 0 To 9
If BadGuys(i).Bulletc(j).Activated = 1 Then
   BadGuys(i).Bulletc(j).x = BadGuys(i).Bulletc(j).x + Cos((36 * j) * Radians) * 20
   BadGuys(i).Bulletc(j).y = BadGuys(i).Bulletc(j).y + Sin((36 * j) * Radians) * 20
'   BadGuys(i).Bulletc(j).x = BadGuys(i).Bulletc(j).x + (BulletSpeed * Cos(BadGuys(i).Bulletc(j).angle * Radians))
'   BadGuys(i).Bulletc(j).y = BadGuys(i).Bulletc(j).y - (BulletSpeed * Sin(BadGuys(i).Bulletc(j).angle * Radians))
   If (BadGuys(i).Bulletc(j).x > frmMain.ScaleWidth) Or _
      (BadGuys(i).Bulletc(j).x < frmMain.ScaleLeft) Or _
      (BadGuys(i).Bulletc(j).y > frmMain.ScaleHeight) Or _
      (BadGuys(i).Bulletc(j).y < frmMain.ScaleTop) Then BadGuys(i).Bulletc(j).Activated = 0

   BitBlt frmMain.picBuf.hdc, BadGuys(i).Bulletc(j).x, BadGuys(i).Bulletc(j).y, 8, 8, frmMain.PicBullet2M.hdc, 0, 0, vbMergePaint
   BitBlt frmMain.picBuf.hdc, BadGuys(i).Bulletc(j).x, BadGuys(i).Bulletc(j).y, 8, 8, frmMain.PicBulletA.hdc, 0, 0, vbSrcAnd
  
   If ShipSprite.Status = True Then
      If BadGuys(i).Bulletc(j).x + 8 > Shipx And BadGuys(i).Bulletc(j).y + 8 > Shipy And _
         BadGuys(i).Bulletc(j).x + 8 < Shipx + 51 And BadGuys(i).Bulletc(j).y + 8 < Shipy + 51 Then
            Call PlaySound(dsHit)
            Shields = Shields - 5
            If Shields <= 0 Then Shipexploding = True
            BadGuys(i).Bulletc(j).Activated = 0
      End If
   End If
End If
Next j
Next i

'Alien Exploding
For i = 0 To UBound(BadGuys)
    If BadGuys(i).Exploding = True Then
       If BadGuys(i).frameExploding = 0 Then
          For s = 0 To 5
              Explosions(s).x = BadGuys(i).x - frmMain.AppoPicm.Width / 4
              Explosions(s).y = BadGuys(i).y - frmMain.AppoPicm.Height / 4
          Next s
          BadGuys(i).frameExploding = 1
       End If
       If BadGuys(i).frameExploding = 1 Then
          Call PlaySound(dsAlienXpl)
       End If
       If BadGuys(i).frameExploding <> 0 Then
           For s = 0 To 5
               If s < 2 Then
                  BitBlt frmMain.picBuf.hdc, Explosions(s).x, Explosions(s).y, 60, 60, frmMain.Explo1m.hdc, 60 * BadGuys(i).frameExploding, 0, vbPatInvert
                  BitBlt frmMain.picBuf.hdc, Explosions(s).x, Explosions(s).y, 60, 60, frmMain.Explo1.hdc, 60 * BadGuys(i).frameExploding, 0, vbSrcPaint
               Else
                  BitBlt frmMain.picBuf.hdc, Explosions(s).x, Explosions(s).y, 80, 70, frmMain.Explo2m.hdc, 80 * BadGuys(i).frameExploding, 0, vbPatInvert
                  BitBlt frmMain.picBuf.hdc, Explosions(s).x, Explosions(s).y, 80, 70, frmMain.Explo2.hdc, 80 * BadGuys(i).frameExploding, 0, vbSrcPaint
               End If
           Next s
           BadGuys(i).frameExploding = BadGuys(i).frameExploding + 1
        End If
  
       If BadGuys(i).frameExploding >= 14 Then
          BadGuys(i).Exploding = False
          BadGuys(i).frameExploding = 0
          Points = Points + 500
       End If
   End If

Next i
End Sub
Public Sub AngleRadians()

    deltax = (Shipx + 25) - curX
    deltay = (Shipy + 25) - curY
    
    If deltax = 0 Then      'Vertical
        If deltay < 0 Then
            angle = Pi / 2
        Else
            angle = Pi * 1.5
        End If
    
    ElseIf deltay = 0 Then  'Horizontal
        If deltax >= 0 Then
            angle = 0
        Else
            angle = Pi
        End If
    
    Else
        angle = Atn(Abs(deltay / deltax))
        
        If deltax >= 0 And deltay >= 0 Then
            angle = (Pi * 2) - angle
            
        ElseIf deltax < 0 And deltay >= 0 Then
            angle = Pi + angle
            
        ElseIf deltax < 0 And deltay < 0 Then
            angle = Pi - angle
            
        End If
        
    End If
    angle = angle * (180# / Pi)
End Sub
