Attribute VB_Name = "modDrawText"
'This module was created by Eric O'Sullivan

Public Declare Function DrawText Lib "user32" Alias "DrawTextA" (ByVal hdc As Long, ByVal lpStr As String, ByVal nCount As Long, lpRect As Rect, ByVal wFormat As Long) As Long
Public Declare Function SetTextColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Public Declare Function SetBkMode Lib "gdi32" (ByVal hdc As Long, ByVal nBkMode As Long) As Long
Public Declare Function GetClientRect Lib "user32" (ByVal hwnd As Long, lpRect As Rect) As Long
Public Declare Function SetRect Lib "user32" (lpRect As Rect, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Public Declare Function CreateBrushIndirect Lib "gdi32" (lpLogBrush As LogBrush) As Long
Public Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Public Declare Function FillRect Lib "user32" (ByVal hwnd As Long, Fill As Rect, HBrush As Long) As Integer
Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Public Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Public Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Public Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Public Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Public Declare Function CreateFontIndirect Lib "gdi32" Alias "CreateFontIndirectA" (lpLogFont As LogFont) As Long
Public Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long

Public Type LogFont
        lfHeight As Long
        lfWidth As Long
        lfEscapement As Long
        lfOrientation As Long
        lfWeight As Long
        lfItalic As Byte
        lfUnderline As Byte
        lfStrikeOut As Byte
        lfCharSet As Byte
        lfOutPrecision As Byte
        lfClipPrecision As Byte
        lfQuality As Byte
        lfPitchAndFamily As Byte
        lfFaceName(1 To 32) As Byte
End Type

Public Type Rect
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type

Public Type LogBrush
        lbStyle As Long
        lbColor As Long
        lbHatch As Long
End Type

'DrawText constants
Public Const DT_CENTER = &H1
Public Const DT_BOTTOM = &H8
Public Const DT_CALCRECT = &H400
Public Const DT_EXPANDTABS = &H40
Public Const DT_EXTERNALLEADING = &H200
Public Const DT_LEFT = &H0
Public Const DT_NOCLIP = &H100
Public Const DT_NOPREFIX = &H800
Public Const DT_RIGHT = &H2
Public Const DT_SINGLELINE = &H20
Public Const DT_TABSTOP = &H80
Public Const DT_TOP = &H0
Public Const DT_VCENTER = &H4
Public Const DT_WORDBREAK = &H10
Public Const TRANSPARENT = 1
Public Const OPAQUE = 2

'CreateBrushIndirect constants
Public Const BS_HATCHED = 2
Public Const BS_HOLLOW = Null
Public Const BS_PATTERN = 3
Public Const BS_SOLID = 0

'BitBlt constants
Public Const SRCAND = &H8800C6       ' (DWORD) dest = source AND dest
Public Const SRCCOPY = &HCC0020      ' (DWORD) dest = source
Public Const SRCERASE = &H440328     ' (DWORD) dest = source AND (NOT dest )
Public Const SRCINVERT = &H660046    ' (DWORD) dest = source XOR dest
Public Const SRCPAINT = &HEE0086     ' (DWORD) dest = source OR dest
Public Const PATCOPY = &HF00021      ' (DWORD) dest = pattern
Public Const PATINVERT = &H5A0049    ' (DWORD) dest = pattern XOR dest
Public Const PATPAINT = &HFB0A09     ' (DWORD) dest = DPSnoo
Public Const MERGECOPY = &HC000CA    ' (DWORD) dest = (source AND pattern)
Public Const MERGEPAINT = &HBB0226   ' (DWORD) dest = (NOT source) OR dest
Public Const NOTSRCCOPY = &H330008   ' (DWORD) dest = (NOT source)
Public Const NOTSRCERASE = &H1100A6  ' (DWORD) dest = (NOT src) AND (NOT dest)

'LogFont constants
Public Const LF_FACESIZE = 32
Public Const FW_BOLD = 700
Public Const FW_DONTCARE = 0
Public Const FW_EXTRABOLD = 800
Public Const FW_EXTRALIGHT = 200
Public Const FW_HEAVY = 900
Public Const FW_LIGHT = 300
Public Const FW_MEDIUM = 500
Public Const FW_NORMAL = 400
Public Const FW_SEMIBOLD = 600
Public Const FW_THIN = 100
Public Const DEFAULT_CHARSET = 1
Public Const OUT_CHARACTER_PRECIS = 2
Public Const OUT_DEFAULT_PRECIS = 0
Public Const OUT_DEVICE_PRECIS = 5
Public Const OUT_OUTLINE_PRECIS = 8
Public Const OUT_RASTER_PRECIS = 6
Public Const OUT_STRING_PRECIS = 1
Public Const OUT_STROKE_PRECIS = 3
Public Const OUT_TT_ONLY_PRECIS = 7
Public Const OUT_TT_PRECIS = 4
Public Const CLIP_CHARACTER_PRECIS = 1
Public Const CLIP_DEFAULT_PRECIS = 0
Public Const CLIP_EMBEDDED = 128
Public Const CLIP_LH_ANGLES = 16
Public Const CLIP_MASK = &HF
Public Const CLIP_STROKE_PRECIS = 2
Public Const CLIP_TT_ALWAYS = 32
Public Const WM_SETFONT = &H30
Public Const LF_FULLFACESIZE = 64
Public Const DEFAULT_PITCH = 0
Public Const DEFAULT_QUALITY = 0
Public Const PROOF_QUALITY = 2

'GetDeviceCaps constants
Public Const LOGPIXELSY = 90        '  Logical pixels/inch in Y

'store information on where what was displayed in the selected
'area before the text was displayed.
Private hDcMemOld As Long
Private hDcBmpOld As Long
Private hDcOldPtr As Long
Private OldRect As Rect

Public Sub ShowText(MyForm As Form, MyString As String, Colour As Long, Top As Integer, Left As Integer, Width As Integer, Height As Integer, Optional Reset As Boolean, Optional Alignment As AlignmentConstants)
'displays the text onto a form (left-justified if not specified)

Static OldBackLoaded As Boolean

Dim MyRect As Rect
Dim TextRect As Rect
Dim TextLen As Long
Dim Result As Long
Dim Junk As Long

'bitmap to copy text from, onto the form
'-----------
Dim hDcMemNew As Long
Dim hDcBmpNew As Long
Dim hDcNewPtr As Long
Dim NewRect As Rect
'-----------

'font details
Dim HDcOldFont As Long
Dim hDcFont As Long
Dim FontStruc As LogFont
Dim Counter As Integer
Dim Align As Long

If MyString = "" Then
    'exit if there is no string to display
    Exit Sub
End If

'change to pixels (for the api calls)
Width = Width / Screen.TwipsPerPixelX
Height = Height / Screen.TwipsPerPixelY

'change the co-ordinates of where the text is going to be displayed
'into pixels for the api calls.
MyRect.Top = (Top / Screen.TwipsPerPixelY)
MyRect.Bottom = ((Top / Screen.TwipsPerPixelY) + Height)
MyRect.Left = (Left / Screen.TwipsPerPixelX)
MyRect.Right = ((Left / Screen.TwipsPerPixelX) + Width)

'copy the background where the text is going to be displayed (this
'means that I can display "transparent"-background text.
If (Not OldBackLoaded) Or (IsNotEqual(MyRect, OldRect)) Or (Reset) Then
    'copy background
    Call DeleteOldBack
    Call LoadOldBack(MyForm, MyRect)
    OldBackLoaded = True
End If

'record how many characters we're going to display
TextLen = Len(MyString)

'create a new rectangle with so that we can create an off-screen
'bitmap before displaying the text on the screen
NewRect = MyRect

'Create off-screen bitmap and select it (also storing where it is so I
'can delete it later once the text is displayed)
Result = GetClientRect(MyForm.hwnd, NewRect)
hDcMemNew = CreateCompatibleDC(MyForm.hdc)
hDcBmpNew = CreateCompatibleBitmap(MyForm.hdc, (NewRect.Right - NewRect.Left), (NewRect.Bottom - NewRect.Top))
hDcNewPtr = SelectObject(hDcMemNew, hDcBmpNew)

'copy the old background to the off-screen bitmap
Result = BitBlt(hDcMemNew, 0, 0, (NewRect.Right - NewRect.Left), (NewRect.Bottom - NewRect.Top), hDcMemOld, 0, 0, SRCCOPY)

'set the co-ordinates of where the text is going to be displayed on
'the screen.

'set the text co-ordinates
TextRect.Right = MyRect.Right
TextRect.Bottom = MyRect.Bottom

'Create details about the font using the forms' font details
'====================

'convert point size to pixels
FontStruc.lfHeight = -((MyForm.FontSize * GetDeviceCaps(MyForm.hdc, LOGPIXELSY)) / 72) 'MyForm.FontSize
FontStruc.lfCharSet = DEFAULT_CHARSET
FontStruc.lfClipPrecision = CLIP_DEFAULT_PRECIS
FontStruc.lfEscapement = 0

'move the name of the font into the array of characters
For Counter = 1 To Len(MyForm.FontName)
    FontStruc.lfFaceName(Counter) = Asc(Mid(MyForm.FontName, Counter, 1))
Next Counter
FontStruc.lfFaceName(Counter) = 0   'this has to be a Null terminated string

FontStruc.lfItalic = MyForm.FontItalic
FontStruc.lfUnderline = MyForm.FontUnderline
FontStruc.lfStrikeOut = MyForm.FontStrikethru
FontStruc.lfOrientation = 0
FontStruc.lfOutPrecision = OUT_DEFAULT_PRECIS
FontStruc.lfPitchAndFamily = DEFAULT_PITCH
FontStruc.lfQuality = PROOF_QUALITY

If MyForm.FontBold Then
    FontStruc.lfWeight = FW_BOLD
Else
    FontStruc.lfWeight = FW_NORMAL
End If

FontStruc.lfWidth = 0

'set the alignment of the text
Select Case Alignment
Case vbCenter
    Align = DT_CENTER
Case vbLeftJustify
    Align = DT_LEFT
Case vbRightJustify
    Align = DT_RIGHT
End Select

'create the font
hDcFont = CreateFontIndirect(FontStruc)
'store the pointer to the font object
HDcOldFont = SelectObject(hDcMemNew, hDcFont)
'====================

'Draw the text into the off-screen bitmap before copying the
'new bitmap (with the text) onto the screen.
Result = SetBkMode(hDcMemNew, TRANSPARENT)
Result = SetTextColor(hDcMemNew, Colour)

'draw the new-built text onto the temperory off-screen bitmap
Result = DrawText(hDcMemNew, MyString, TextLen, TextRect, Align)

'copy the temperory bitmap wiht the text onto the form
Result = BitBlt(MyForm.hdc, MyRect.Left, MyRect.Top, Width, Height, hDcMemNew, 0, 0, SRCCOPY)

'clean up by deleting the off-screen bitmap and font
Junk = SelectObject(hDcMemNew, HDcOldFont)
Junk = DeleteObject(hDcFont)
Junk = SelectObject(hDcMemNew, hDcNewPtr)
Junk = DeleteObject(hDcBmpNew)
Junk = DeleteDC(hDcMemNew)
End Sub

Private Sub LoadOldBack(ByVal TheForm As Form, AreaToLoad As Rect)
'This procedure will load a section of the form into an off-screen
'bitmap for use in the ShowText procedure.

Dim Result As Long

'Create off-screen bitmap and select it (also storing where it is so I
'can delete it later once the text is displayed)
OldRect = AreaToLoad
hDcMemOld = CreateCompatibleDC(TheForm.hdc)
hDcBmpOld = CreateCompatibleBitmap(TheForm.hdc, (OldRect.Right - OldRect.Left), (OldRect.Bottom - OldRect.Top))
hDcOldPtr = SelectObject(hDcMemOld, hDcBmpOld)

'copy the old background to the off-screen bitmap
Result = BitBlt(hDcMemOld, 0, 0, (OldRect.Right - OldRect.Left), (OldRect.Bottom - OldRect.Top), TheForm.hdc, OldRect.Left, OldRect.Top, SRCCOPY)
End Sub

Public Sub DeleteOldBack()
'This will remove the bitmap that sotred what was displayed before
'the text was written to the screen, from memory.

Dim Junk As Long

If hDcMemOld = 0 Then
    'there is nothing to delete. Exit the sub-routine
    Exit Sub
End If

Junk = SelectObject(hDcMemOld, hDcOldPtr)
Junk = DeleteObject(hDcBmpOld)
Junk = DeleteDC(hDcMemOld)
End Sub

Public Function IsNotEqual(Rect1 As Rect, Rect2 As Rect) As Boolean
'This compares two Rect structures and returns True if they both
'are equal. Otherwise the function returns False

IsEqual = False

If (Rect1.Left <> Rect2.Left) Or (Rect1.Bottom <> Rect2.Bottom) Or (Rect1.Top <> Rect2.Top) Or (Rect1.Right <> Rect2.Right) Then
    IsEqual = True
End If
End Function

